Index: trunk/LMDZ.GENERIC/libf/phystd/physiq.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/physiq.F90	(revision 1470)
+++ trunk/LMDZ.GENERIC/libf/phystd/physiq.F90	(revision 1477)
@@ -52,54 +52,67 @@
 !   It includes:
 !
-!      1.  Initialization:
-!      1.1 Firstcall initializations
-!      1.2 Initialization for every call to physiq
-!      1.2.5 Compute mean mass and cp, R and thermal conduction coeff.
-!      2. Compute radiative transfer tendencies
-!         (longwave and shortwave).
-!      4. Vertical diffusion (turbulent mixing):
-!      5. Convective adjustment
-!      6. Condensation and sublimation of gases (currently just CO2).
-!      7. TRACERS
-!       7a. water and water ice
-!       7c. other schemes for tracer transport (lifting, sedimentation)
-!       7d. updates (pressure variations, surface budget)
-!      9. Surface and sub-surface temperature calculations
-!     10. Write outputs :
-!           - "startfi", "histfi" if it's time
-!           - Saving statistics if "callstats = .true."
-!           - Output any needed variables in "diagfi" 
-!     10. Diagnostics: mass conservation of tracers, radiative energy balance etc.
+!      I. Initialization :
+!         I.1 Firstcall initializations.
+!         I.2 Initialization for every call to physiq.
+!
+!      II. Compute radiative transfer tendencies (longwave and shortwave) :
+!         II.a Option 1 : Call correlated-k radiative transfer scheme.
+!         II.b Option 2 : Call Newtonian cooling scheme.
+!         II.c Option 3 : Atmosphere has no radiative effect.
+!
+!      III. Vertical diffusion (turbulent mixing) :
+!
+!      IV. Dry Convective adjustment :
+!
+!      V. Condensation and sublimation of gases (currently just CO2).
+!
+!      VI. Tracers
+!         VI.1. Water and water ice.
+!         VI.2. Aerosols and particles.
+!         VI.3. Updates (pressure variations, surface budget).
+!         VI.4. Slab Ocean.
+!         VI.5. Surface Tracer Update.
+!
+!      VII. Surface and sub-surface soil temperature.
+!
+!      VIII. Perform diagnostics and write output files.
+!
 !
 !   arguments
 !   ---------
 !
-!   input
+!   INPUT
 !   -----
-!    ecri                  period (in dynamical timestep) to write output
+!
 !    ngrid                 Size of the horizontal grid.
-!                          All internal loops are performed on that grid.
 !    nlayer                Number of vertical layers.
-!    nq                    Number of advected fields
-!    firstcall             True at the first call
-!    lastcall              True at the last call
-!    pday                  Number of days counted from the North. Spring
-!                          equinoxe.
-!    ptime                 Universal time (0<ptime<1): ptime=0.5 at 12:00 UT
-!    ptimestep             timestep (s)
-!    pplay(ngrid,nlayer)   Pressure at the middle of the layers (Pa)
-!    pplev(ngrid,nlayer+1) intermediate pressure levels (pa)
-!    pphi(ngrid,nlayer)    Geopotential at the middle of the layers (m2s-2)
-!    pu(ngrid,nlayer)      u component of the wind (ms-1)
-!    pv(ngrid,nlayer)      v component of the wind (ms-1)
-!    pt(ngrid,nlayer)      Temperature (K)
-!    pq(ngrid,nlayer,nq)   Advected fields
+!    nq                    Number of advected fields.
+!    nametrac              Name of corresponding advected fields.
+!
+!    firstcall             True at the first call.
+!    lastcall              True at the last call.
+!
+!    pday                  Number of days counted from the North. Spring equinoxe.
+!    ptime                 Universal time (0<ptime<1): ptime=0.5 at 12:00 UT.
+!    ptimestep             timestep (s).
+!
+!    pplay(ngrid,nlayer)   Pressure at the middle of the layers (Pa).
+!    pplev(ngrid,nlayer+1) Intermediate pressure levels (Pa).
+!    pphi(ngrid,nlayer)    Geopotential at the middle of the layers (m2.s-2).
+!
+!    pu(ngrid,nlayer)      u, zonal component of the wind (ms-1).
+!    pv(ngrid,nlayer)      v, meridional component of the wind (ms-1).
+!
+!    pt(ngrid,nlayer)      Temperature (K).
+!
+!    pq(ngrid,nlayer,nq)   Advected fields.
+!
 !    pudyn(ngrid,nlayer)    \
 !    pvdyn(ngrid,nlayer)     \ Dynamical temporal derivative for the
-!    ptdyn(ngrid,nlayer)     / corresponding variables
+!    ptdyn(ngrid,nlayer)     / corresponding variables.
 !    pqdyn(ngrid,nlayer,nq) /
 !    flxw(ngrid,nlayer)      vertical mass flux (kg/s) at layer lower boundary
 !
-!   output
+!   OUTPUT
 !   ------
 !
@@ -127,4 +140,5 @@
 !           Loops converted to F90 matrix format: J. Leconte (2012)
 !           No more ngridmx/nqmx, F90 commons and adaptation to parallel: A. Spiga (2012)
+!           Purge of the code : M. Turbet (2015)
 !==================================================================
 
@@ -138,66 +152,68 @@
 ! -----------
 
-!   inputs:
+!   INPUTS:
 !   -------
-      integer,intent(in) :: ngrid ! number of atmospheric columns
-      integer,intent(in) :: nlayer ! number of atmospheric layers
-      integer,intent(in) :: nq ! number of tracers
-      character*20,intent(in) :: nametrac(nq) ! name of the tracer from dynamics
-      logical,intent(in) :: firstcall ! signals first call to physics
-      logical,intent(in) :: lastcall ! signals last call to physics
-      real,intent(in) :: pday ! number of elapsed sols since reference Ls=0
-      real,intent(in) :: ptime ! "universal time", given as fraction of sol (e.g.: 0.5 for noon)
-      real,intent(in) :: ptimestep ! physics timestep (s)
-      real,intent(in) :: pplev(ngrid,nlayer+1) ! inter-layer pressure (Pa)
-      real,intent(in) :: pplay(ngrid,nlayer) ! mid-layer pressure (Pa)
-      real,intent(in) :: pphi(ngrid,nlayer) ! geopotential at mid-layer (m2s-2)
-      real,intent(in) :: pu(ngrid,nlayer) ! zonal wind component (m/s)
-      real,intent(in) :: pv(ngrid,nlayer) ! meridional wind component (m/s)
-      real,intent(in) :: pt(ngrid,nlayer) ! temperature (K)
-      real,intent(in) :: pq(ngrid,nlayer,nq) ! tracers (.../kg_of_air)
-      real,intent(in) :: flxw(ngrid,nlayer) ! vertical mass flux (ks/s)
-                                            ! at lower boundary of layer
-
-
-!   outputs:
+
+      integer,intent(in) :: ngrid             ! Number of atmospheric columns.
+      integer,intent(in) :: nlayer            ! Number of atmospheric layers.
+      integer,intent(in) :: nq                ! Number of tracers.
+      character*20,intent(in) :: nametrac(nq) ! Names of the tracers taken from dynamics.
+      
+      logical,intent(in) :: firstcall ! Signals first call to physics.
+      logical,intent(in) :: lastcall  ! Signals last call to physics.
+      
+      real,intent(in) :: pday                  ! Number of elapsed sols since reference Ls=0.
+      real,intent(in) :: ptime                 ! "Universal time", given as fraction of sol (e.g.: 0.5 for noon).
+      real,intent(in) :: ptimestep             ! Physics timestep (s).
+      real,intent(in) :: pplev(ngrid,nlayer+1) ! Inter-layer pressure (Pa).
+      real,intent(in) :: pplay(ngrid,nlayer)   ! Mid-layer pressure (Pa).
+      real,intent(in) :: pphi(ngrid,nlayer)    ! Geopotential at mid-layer (m2s-2).
+      real,intent(in) :: pu(ngrid,nlayer)      ! Zonal wind component (m/s).
+      real,intent(in) :: pv(ngrid,nlayer)      ! Meridional wind component (m/s).
+      real,intent(in) :: pt(ngrid,nlayer)      ! Temperature (K).
+      real,intent(in) :: pq(ngrid,nlayer,nq)   ! Tracers (kg/kg_of_air).
+      real,intent(in) :: flxw(ngrid,nlayer)    ! Vertical mass flux (ks/s) at lower boundary of layer
+
+!   OUTPUTS:
 !   --------
-!     physical tendencies
-      real,intent(out) :: pdu(ngrid,nlayer) ! zonal wind tendency (m/s/s)
-      real,intent(out) :: pdv(ngrid,nlayer) ! meridional wind tendency (m/s/s)
-      real,intent(out) :: pdt(ngrid,nlayer) ! temperature tendency (K/s)
-      real,intent(out) :: pdq(ngrid,nlayer,nq) ! tracer tendencies (../kg/s)
-      real,intent(out) :: pdpsrf(ngrid) ! surface pressure tendency (Pa/s)
-      logical,intent(out) :: tracerdyn ! signal to the dynamics to advect tracers or not
+
+!     Physical tendencies :
+
+      real,intent(out) :: pdu(ngrid,nlayer)    ! Zonal wind tendencies (m/s/s).
+      real,intent(out) :: pdv(ngrid,nlayer)    ! Meridional wind tendencies (m/s/s).
+      real,intent(out) :: pdt(ngrid,nlayer)    ! Temperature tendencies (K/s).
+      real,intent(out) :: pdq(ngrid,nlayer,nq) ! Tracer tendencies (kg/kg_of_air/s).
+      real,intent(out) :: pdpsrf(ngrid)        ! Surface pressure tendency (Pa/s).
+      logical,intent(out) :: tracerdyn         ! Signal to the dynamics to advect tracers or not.     
 
 ! Local saved variables:
 ! ----------------------
-!     aerosol (dust or ice) extinction optical depth  at reference wavelength 
-!     "longrefvis" set in dimradmars.h , for one of the "naerkind"  kind of
-!      aerosol optical properties:
-!      real aerosol(ngrid,nlayer,naerkind) 
-!     this is now internal to callcorrk and hence no longer needed here
-
-      integer day_ini                ! Initial date of the run (sol since Ls=0) 
-      integer icount                 ! counter of calls to physiq during the run.
-      real, dimension(:),allocatable,save ::  tsurf  ! Surface temperature (K)
-      real, dimension(:,:),allocatable,save ::  tsoil  ! sub-surface temperatures (K)
-      real, dimension(:),allocatable,save :: albedo ! Surface albedo
+
+      integer day_ini                                  ! Initial date of the run (sol since Ls=0).
+      integer icount                                   ! Counter of calls to physiq during the run.
+      real, dimension(:),allocatable,save ::  tsurf    ! Surface temperature (K).
+      real, dimension(:,:),allocatable,save ::  tsoil  ! Sub-surface temperatures (K).
+      real, dimension(:),allocatable,save :: albedo    ! Surface albedo.
+      
 !$OMP THREADPRIVATE(tsurf,tsoil,albedo)
 
-      real,dimension(:),allocatable,save :: albedo0 ! Surface albedo
-      real,dimension(:),allocatable,save :: rnat ! added by BC
+      real,dimension(:),allocatable,save :: albedo0 ! Initial surface albedo.
+      real,dimension(:),allocatable,save :: rnat    ! Defines the type of the grid (ocean,continent,...). By BC.
+      
 !$OMP THREADPRIVATE(albedo0,rnat)
 
-      real,dimension(:),allocatable,save :: emis ! Thermal IR surface emissivity
-      real,dimension(:,:),allocatable,save :: dtrad ! Net atm. radiative heating rate (K.s-1)
-      real,dimension(:),allocatable,save :: fluxrad_sky ! rad. flux from sky absorbed by surface (W.m-2)
-      real,dimension(:),allocatable,save :: fluxrad ! Net radiative surface flux (W.m-2)
-      real,dimension(:),allocatable,save :: capcal ! surface heat capacity (J m-2 K-1)
-      real,dimension(:),allocatable,save :: fluxgrd ! surface conduction flux (W.m-2)
-      real,dimension(:,:),allocatable,save :: qsurf ! tracer on surface (e.g. kg.m-2)
-      real,dimension(:,:),allocatable,save :: q2 ! Turbulent Kinetic Energy 
+      real,dimension(:),allocatable,save :: emis        ! Thermal IR surface emissivity.
+      real,dimension(:,:),allocatable,save :: dtrad     ! Net atmospheric radiative heating rate (K.s-1).
+      real,dimension(:),allocatable,save :: fluxrad_sky ! Radiative flux from sky absorbed by surface (W.m-2).
+      real,dimension(:),allocatable,save :: fluxrad     ! Net radiative surface flux (W.m-2).
+      real,dimension(:),allocatable,save :: capcal      ! Surface heat capacity (J m-2 K-1).
+      real,dimension(:),allocatable,save :: fluxgrd     ! Surface conduction flux (W.m-2).
+      real,dimension(:,:),allocatable,save :: qsurf     ! Tracer on surface (e.g. kg.m-2).
+      real,dimension(:,:),allocatable,save :: q2        ! Turbulent Kinetic Energy.
+      
 !$OMP THREADPRIVATE(emis,dtrad,fluxrad_sky,fluxrad,capcal,fluxgrd,qsurf,q2)
 
       save day_ini, icount
+      
 !$OMP THREADPRIVATE(day_ini,icount)
 
@@ -205,80 +221,96 @@
 ! -----------------
 
-!     aerosol (dust or ice) extinction optical depth  at reference wavelength 
+!     Aerosol (dust or ice) extinction optical depth  at reference wavelength 
 !     for the "naerkind" optically active aerosols:
-      real aerosol(ngrid,nlayer,naerkind) 
-      real zh(ngrid,nlayer)      ! potential temperature (K)
-      real pw(ngrid,nlayer) ! vertical velocity (m/s) (>0 when downwards)
-
-      character*80 fichier 
-      integer l,ig,ierr,iq,iaer
-      
-      !!! this is saved for diagnostic
-      real,dimension(:),allocatable,save :: fluxsurf_lw ! incident LW (IR) surface flux (W.m-2)
-      real,dimension(:),allocatable,save :: fluxsurf_sw ! incident SW (stellar) surface flux (W.m-2)
-      real,dimension(:),allocatable,save :: fluxtop_lw ! Outgoing LW (IR) flux to space (W.m-2)
-      real,dimension(:),allocatable,save :: fluxabs_sw ! Absorbed SW (stellar) flux (W.m-2)
-      real,dimension(:),allocatable,save :: fluxtop_dn
-      real,dimension(:),allocatable,save :: fluxdyn ! horizontal heat transport by dynamics  
-      real,dimension(:,:),allocatable,save :: OLR_nu ! Outgoing LW radition in each band (Normalized to the band width (W/m2/cm-1)
-      real,dimension(:,:),allocatable,save :: OSR_nu ! Outgoing SW radition in each band (Normalized to the band width (W/m2/cm-1)
-      real,dimension(:,:),allocatable,save :: zdtlw ! (K/s)
-      real,dimension(:,:),allocatable,save :: zdtsw ! (K/s)
-      real,dimension(:),allocatable,save :: sensibFlux ! turbulent flux given by the atm to the surface
+
+      real aerosol(ngrid,nlayer,naerkind) ! Aerosols.
+      real zh(ngrid,nlayer)               ! Potential temperature (K).
+      real pw(ngrid,nlayer)               ! Vertical velocity (m/s). (NOTE : >0 WHEN DOWNWARDS !!)
+
+      integer l,ig,ierr,iq
+      
+      ! FOR DIAGNOSTIC :
+      
+      real,dimension(:),allocatable,save :: fluxsurf_lw  ! Incident Long Wave (IR) surface flux (W.m-2).
+      real,dimension(:),allocatable,save :: fluxsurf_sw  ! incident Short Wave (stellar) surface flux (W.m-2).
+      real,dimension(:),allocatable,save :: fluxtop_lw   ! Outgoing LW (IR) flux to space (W.m-2).
+      real,dimension(:),allocatable,save :: fluxabs_sw   ! Absorbed SW (stellar) flux (W.m-2).
+      real,dimension(:),allocatable,save :: fluxtop_dn   ! Incoming SW (stellar) radiation at the top of the atmosphere (W.m-2).
+      real,dimension(:),allocatable,save :: fluxdyn      ! Horizontal heat transport by dynamics (W.m-2).
+      real,dimension(:,:),allocatable,save :: OLR_nu     ! Outgoing LW radiation in each band (Normalized to the band width (W/m2/cm-1)).
+      real,dimension(:,:),allocatable,save :: OSR_nu     ! Outgoing SW radiation in each band (Normalized to the band width (W/m2/cm-1)).
+      real,dimension(:,:),allocatable,save :: zdtlw      ! LW heating tendencies (K/s).
+      real,dimension(:,:),allocatable,save :: zdtsw      ! SW heating tendencies (K/s).
+      real,dimension(:),allocatable,save :: sensibFlux   ! Turbulent flux given by the atmosphere to the surface (W.m-2).
+      
 !$OMP THREADPRIVATE(fluxsurf_lw,fluxsurf_sw,fluxtop_lw,fluxabs_sw,fluxtop_dn,fluxdyn,OLR_nu,OSR_nu,&
-	!$OMP zdtlw,zdtsw,sensibFlux)
-
-      real zls                       ! solar longitude (rad)
-      real zlss                      ! sub solar point longitude (rad)
-      real zday                      ! date (time since Ls=0, in martian days)
-      real zzlay(ngrid,nlayer)   ! altitude at the middle of the layers
-      real zzlev(ngrid,nlayer+1) ! altitude at layer boundaries
-      real latvl1,lonvl1             ! Viking Lander 1 point (for diagnostic)
-
-!     Tendencies due to various processes:
-      real dqsurf(ngrid,nq)
-      real cldtlw(ngrid,nlayer)                           ! (K/s) LW heating rate for clear areas
-      real cldtsw(ngrid,nlayer)                           ! (K/s) SW heating rate for clear areas
-      real zdtsurf(ngrid)                                   ! (K/s)
-      real dtlscale(ngrid,nlayer)
-      real zdvdif(ngrid,nlayer),zdudif(ngrid,nlayer)  ! (m.s-2)
-      real zdhdif(ngrid,nlayer), zdtsdif(ngrid)         ! (K/s)
-      real zdtdif(ngrid,nlayer)			      ! (K/s)
-      real zdvadj(ngrid,nlayer),zduadj(ngrid,nlayer)  ! (m.s-2)
-      real zdhadj(ngrid,nlayer)                           ! (K/s)
-      real zdtgw(ngrid,nlayer)                            ! (K/s)
-      real zdtmr(ngrid,nlayer)
-      real zdugw(ngrid,nlayer),zdvgw(ngrid,nlayer)    ! (m.s-2)
-      real zdtc(ngrid,nlayer),zdtsurfc(ngrid)
-      real zdvc(ngrid,nlayer),zduc(ngrid,nlayer)
-      real zdumr(ngrid,nlayer),zdvmr(ngrid,nlayer)
-      real zdtsurfmr(ngrid)
-      
-      real zdmassmr(ngrid,nlayer),zdpsrfmr(ngrid)
-      real zdmassmr_col(ngrid)
-
-      real zdqdif(ngrid,nlayer,nq), zdqsdif(ngrid,nq)
-      real zdqevap(ngrid,nlayer)
-      real zdqsed(ngrid,nlayer,nq), zdqssed(ngrid,nq)
-      real zdqdev(ngrid,nlayer,nq), zdqsdev(ngrid,nq)
-      real zdqadj(ngrid,nlayer,nq)
-      real zdqc(ngrid,nlayer,nq)
-      real zdqmr(ngrid,nlayer,nq),zdqsurfmr(ngrid,nq)
-      real zdqlscale(ngrid,nlayer,nq)
-      real zdqslscale(ngrid,nq)
-      real zdqchim(ngrid,nlayer,nq)
-      real zdqschim(ngrid,nq)
-
-      real zdteuv(ngrid,nlayer)    ! (K/s)
-      real zdtconduc(ngrid,nlayer) ! (K/s)
-      real zdumolvis(ngrid,nlayer)
-      real zdvmolvis(ngrid,nlayer)
-      real zdqmoldiff(ngrid,nlayer,nq)
-
-!     Local variables for local calculations:
+	
+        !$OMP zdtlw,zdtsw,sensibFlux)
+
+      real zls                       ! Solar longitude (radians).
+      real zlss                      ! Sub solar point longitude (radians).
+      real zday                      ! Date (time since Ls=0, calculated in sols).
+      real zzlay(ngrid,nlayer)       ! Altitude at the middle of the atmospheric layers.
+      real zzlev(ngrid,nlayer+1)     ! Altitude at the atmospheric layer boundaries.
+
+! TENDENCIES due to various processes :
+
+      ! For Surface Temperature : (K/s)
+      real zdtsurf(ngrid)     ! Cumulated tendencies.
+      real zdtsurfmr(ngrid)   ! Mass_redistribution routine.
+      real zdtsurfc(ngrid)    ! Condense_co2 routine.
+      real zdtsdif(ngrid)     ! Turbdiff/vdifc routines.
+      real zdtsurf_hyd(ngrid) ! Hydrol routine.
+            
+      ! For Atmospheric Temperatures : (K/s)    
+      real dtlscale(ngrid,nlayer)                             ! Largescale routine.
+      real zdtc(ngrid,nlayer)                                 ! Condense_co2 routine.
+      real zdtdif(ngrid,nlayer)	                              ! Turbdiff/vdifc routines.
+      real zdtmr(ngrid,nlayer)                                ! Mass_redistribution routine.
+      real zdtrain(ngrid,nlayer)                              ! Rain routine.
+      real dtmoist(ngrid,nlayer)                              ! Moistadj routine.
+      real dt_ekman(ngrid,noceanmx), dt_hdiff(ngrid,noceanmx) ! Slab_ocean routine.
+      real zdtsw1(ngrid,nlayer), zdtlw1(ngrid,nlayer)         ! Callcorrk routine.
+                              
+      ! For Surface Tracers : (kg/m2/s)
+      real dqsurf(ngrid,nq)                 ! Cumulated tendencies.
+      real zdqslscale(ngrid,nq)             ! Largescale routine.
+      real zdqsdif(ngrid,nq)                ! Turbdiff/vdifc routines.
+      real zdqssed(ngrid,nq)                ! Callsedim routine.
+      real zdqsurfmr(ngrid,nq)              ! Mass_redistribution routine.
+      real zdqsrain(ngrid), zdqssnow(ngrid) ! Rain routine.
+      real dqs_hyd(ngrid,nq)                ! Hydrol routine.
+                  
+      ! For Tracers : (kg/kg_of_air/s)
+      real zdqc(ngrid,nlayer,nq)      ! Condense_co2 routine.
+      real zdqadj(ngrid,nlayer,nq)    ! Convadj routine.
+      real zdqdif(ngrid,nlayer,nq)    ! Turbdiff/vdifc routines.
+      real zdqevap(ngrid,nlayer)      ! Turbdiff routine.
+      real zdqsed(ngrid,nlayer,nq)    ! Callsedim routine.
+      real zdqmr(ngrid,nlayer,nq)     ! Mass_redistribution routine.
+      real zdqrain(ngrid,nlayer,nq)   ! Rain routine.
+      real dqmoist(ngrid,nlayer,nq)   ! Moistadj routine.
+      real dqvaplscale(ngrid,nlayer)  ! Largescale routine.
+      real dqcldlscale(ngrid,nlayer)  ! Largescale routine.
+                        
+      ! For Winds : (m/s/s)
+      real zdvc(ngrid,nlayer),zduc(ngrid,nlayer)     ! Condense_co2 routine.
+      real zdvadj(ngrid,nlayer),zduadj(ngrid,nlayer) ! Convadj routine.
+      real zdumr(ngrid,nlayer),zdvmr(ngrid,nlayer)   ! Mass_redistribution routine.
+      real zdvdif(ngrid,nlayer),zdudif(ngrid,nlayer) ! Turbdiff/vdifc routines.
+      real zdhdif(ngrid,nlayer)                      ! Turbdiff/vdifc routines.
+      real zdhadj(ngrid,nlayer)                      ! Convadj routine.
+     
+      ! For Pressure and Mass :
+      real zdmassmr(ngrid,nlayer) ! Atmospheric Mass tendency for mass_redistribution (kg_of_air/m2/s).
+      real zdmassmr_col(ngrid)    ! Atmospheric Column Mass tendency for mass_redistribution (kg_of_air/m2/s).
+      real zdpsrfmr(ngrid)        ! Pressure tendency for mass_redistribution routine (Pa/s).
+
+      
+    
+! Local variables for LOCAL CALCULATIONS:
+! ---------------------------------------
       real zflubid(ngrid)
       real zplanck(ngrid),zpopsk(ngrid,nlayer)
-      real zdum1(ngrid,nlayer)
-      real zdum2(ngrid,nlayer)
       real ztim1,ztim2,ztim3, z1,z2
       real ztime_fin
@@ -287,59 +319,29 @@
       real taux(ngrid),tauy(ngrid)
 
-      integer length
-      parameter (length=100)
-
-! local variables only used for diagnostics (output in file "diagfi" or "stats")
-! ------------------------------------------------------------------------------
-      real ps(ngrid), zt(ngrid,nlayer)
-      real zu(ngrid,nlayer),zv(ngrid,nlayer)
-      real zq(ngrid,nlayer,nq)
-      character*2 str2
-      character*5 str5
-      real zdtadj(ngrid,nlayer)
-      real zdtdyn(ngrid,nlayer)
-      real,allocatable,dimension(:,:),save :: ztprevious
+
+! local variables for DIAGNOSTICS : (diagfi & stat)
+! -------------------------------------------------
+      real ps(ngrid)                                     ! Surface Pressure.
+      real zt(ngrid,nlayer)                              ! Atmospheric Temperature.
+      real zu(ngrid,nlayer),zv(ngrid,nlayer)             ! Zonal and Meridional Winds.
+      real zq(ngrid,nlayer,nq)                           ! Atmospheric Tracers.
+      real zdtadj(ngrid,nlayer)                          ! Convadj Diagnostic.
+      real zdtdyn(ngrid,nlayer)                          ! Dynamical Heating (K/s).
+      real,allocatable,dimension(:,:),save :: ztprevious ! Previous loop Atmospheric Temperature (K)                                                         ! Useful for Dynamical Heating calculation.
 !$OMP THREADPRIVATE(ztprevious)
-      real reff(ngrid,nlayer) ! effective dust radius (used if doubleq=T)
-      real qtot1,qtot2            ! total aerosol mass
-      integer igmin, lmin
-      logical tdiag
-
-      real zplev(ngrid,nlayer+1),zplay(ngrid,nlayer)
-      real zstress(ngrid), cd
-      real hco2(nq), tmean, zlocal(nlayer)
-      real vmr(ngrid,nlayer) ! volume mixing ratio
-
+
+      real reff(ngrid,nlayer)                       ! Effective dust radius (used if doubleq=T).
+      real vmr(ngrid,nlayer)                        ! volume mixing ratio
       real time_phys
-
-!     reinstated by RW for diagnostic
-      real,allocatable,dimension(:),save :: tau_col
+      real,allocatable,dimension(:),save :: tau_col ! Total Aerosol Optical Depth.
 !$OMP THREADPRIVATE(tau_col)
       
-!     included by RW to reduce insanity of code
-      real ISR,ASR,OLR,GND,DYN,GSR,Ts1,Ts2,Ts3,TsS
-
-!     included by RW to compute tracer column densities
-      real qcol(ngrid,nq)
-
-!     included by RW for H2O precipitation
-      real zdtrain(ngrid,nlayer)
-      real zdqrain(ngrid,nlayer,nq)
-      real zdqsrain(ngrid)
-      real zdqssnow(ngrid)
-      real rainout(ngrid)
+      real ISR,ASR,OLR,GND,DYN,GSR,Ts1,Ts2,Ts3,TsS ! for Diagnostic.
+      
+      real qcol(ngrid,nq) ! Tracer Column Mass (kg/m2).
 
 !     included by RW for H2O Manabe scheme
-      real dtmoist(ngrid,nlayer)
-      real dqmoist(ngrid,nlayer,nq)
-
-      real qvap(ngrid,nlayer)
-      real dqvaplscale(ngrid,nlayer)
-      real dqcldlscale(ngrid,nlayer)
-      real rneb_man(ngrid,nlayer)
-      real rneb_lsc(ngrid,nlayer)
-
-!     included by RW to account for surface cooling by evaporation
-      real dtsurfh2olat(ngrid)
+      real rneb_man(ngrid,nlayer) ! H2O cloud fraction (moistadj).
+      real rneb_lsc(ngrid,nlayer) ! H2O cloud fraction (large scale).
 
 
@@ -352,94 +354,57 @@
       real dEdiffs(ngrid),dEdiff(ngrid)
       real madjdE(ngrid), lscaledE(ngrid),madjdEz(ngrid,nlayer), lscaledEz(ngrid,nlayer)
+      
 !JL12 conservation test for mean flow kinetic energy has been disabled temporarily
-      real dtmoist_max,dtmoist_min
-      
+
+      real dtmoist_max,dtmoist_min     
       real dItot, dItot_tmp, dVtot, dVtot_tmp
 
-!     included by BC for evaporation     
-      real qevap(ngrid,nlayer,nq)
-      real tevap(ngrid,nlayer)
-      real dqevap1(ngrid,nlayer)
-      real dtevap1(ngrid,nlayer)
-
-!     included by BC for hydrology
-      real,allocatable,save :: hice(:)
+      real,allocatable,save :: hice(:) ! Oceanic Ice height. by BC
  !$OMP THREADPRIVATE(hice)     
 
-!     included by RW to test water conservation (by routine)
-      real h2otot
+      real h2otot                      ! Total Amount of water. For diagnostic.
+      real icesrf,liqsrf,icecol,vapcol ! Total Amounts of water (ice,liq,vap). For diagnostic.
       real dWtot, dWtot_tmp, dWtots, dWtots_tmp
-      real h2o_surf_all
-      logical watertest
-      save watertest
+      logical,save :: watertest
 !$OMP THREADPRIVATE(watertest)
 
-!     included by RW for RH diagnostic
-      real qsat(ngrid,nlayer), RH(ngrid,nlayer), H2Omaxcol(ngrid),psat_tmp
-
-!     included by RW for hydrology
-      real dqs_hyd(ngrid,nq)
-      real zdtsurf_hyd(ngrid)
-
-!     included by RW for water cycle conservation tests
-      real icesrf,liqsrf,icecol,vapcol
-
-!     included by BC for double radiative transfer call
-      logical clearsky
-      real zdtsw1(ngrid,nlayer)
-      real zdtlw1(ngrid,nlayer)
-      real fluxsurf_lw1(ngrid)     
-      real fluxsurf_sw1(ngrid)  
-      real fluxtop_lw1(ngrid)    
-      real fluxabs_sw1(ngrid)  
-      real tau_col1(ngrid)
-      real OLR_nu1(ngrid,L_NSPECTI)
-      real OSR_nu1(ngrid,L_NSPECTV)
+      real qsat(ngrid,nlayer) ! Water Vapor Volume Mixing Ratio at saturation (kg/kg_of_air).
+      real RH(ngrid,nlayer)   ! Relative humidity.
+      real H2Omaxcol(ngrid)   ! Maximum possible H2O column amount (at 100% saturation) (kg/m2).
+      real psat_tmp
+      
+      logical clearsky ! For double radiative transfer call. By BC
+      
+      real fluxsurf_lw1(ngrid), fluxsurf_sw1(ngrid), fluxtop_lw1(ngrid), fluxabs_sw1(ngrid) ! For SW/LW flux diagnostics.
+      real tau_col1(ngrid)                                                                  ! For aerosol optical depth diagnostic.
+      real OLR_nu1(ngrid,L_NSPECTI), OSR_nu1(ngrid,L_NSPECTV)                               ! For Outgoing Radiation diagnostics.
       real tf, ntf
 
-!     included by BC for cloud fraction computations
-      real,allocatable,dimension(:,:),save :: cloudfrac
-      real,allocatable,dimension(:),save :: totcloudfrac
+      real,allocatable,dimension(:,:),save :: cloudfrac  ! Fraction of clouds (%).
+      real,allocatable,dimension(:),save :: totcloudfrac ! Column fraction of clouds (%).
 !$OMP THREADPRIVATE(cloudfrac,totcloudfrac)
 
-!     included by RW for vdifc water conservation test
-      real nconsMAX
-      real vdifcncons(ngrid)
-      real cadjncons(ngrid)
-
-!      double precision qsurf_hist(ngrid,nq)
+      real nconsMAX, vdifcncons(ngrid), cadjncons(ngrid) ! Vdfic water conservation test. By RW
+
       real,allocatable,dimension(:,:),save :: qsurf_hist
 !$OMP THREADPRIVATE(qsurf_hist)
 
-!     included by RW for temp convadj conservation test
-      real playtest(nlayer)
-      real plevtest(nlayer)
-      real ttest(nlayer)
-      real qtest(nlayer)
-      integer igtest
-
-!     included by RW for runway greenhouse 1D study
-      real muvar(ngrid,nlayer+1)
-
-!     included by RW for variable H2O particle sizes
-      real,allocatable,dimension(:,:,:),save :: reffrad ! aerosol effective radius (m)
-      real,allocatable,dimension(:,:,:),save :: nueffrad ! aerosol effective radius variance
+      real muvar(ngrid,nlayer+1) ! For Runaway Greenhouse 1D study. By RW
+
+      real,allocatable,dimension(:,:,:),save :: reffrad  ! Aerosol effective radius (m). By RW
+      real,allocatable,dimension(:,:,:),save :: nueffrad ! Aerosol effective radius variance. By RW
 !$OMP THREADPRIVATE(reffrad,nueffrad)
-!      real :: nueffrad_dummy(ngrid,nlayer,naerkind) !! AS. This is temporary. Check below why.
-      real :: reffh2oliq(ngrid,nlayer) ! liquid water particles effective radius (m)
-      real :: reffh2oice(ngrid,nlayer) ! water ice particles effective radius (m)
-   !   real reffH2O(ngrid,nlayer)
+
       real reffcol(ngrid,naerkind)
 
-!     included by RW for sourceevol
+!     Sourceevol for 'accelerated ice evolution'. By RW
       real,allocatable,dimension(:),save :: ice_initial
       real delta_ice,ice_tot
-      real,allocatable,dimension(:),save :: ice_min
-      
+      real,allocatable,dimension(:),save :: ice_min      
       integer num_run
       logical,save :: ice_update
 !$OMP THREADPRIVATE(ice_initial,ice_min,ice_update)
 
-!     included by BC for slab ocean
+!     For slab ocean. By BC
       real, dimension(:),allocatable,save ::  pctsrf_sic
       real, dimension(:,:),allocatable,save :: tslab
@@ -452,19 +417,20 @@
       real :: tsurf2(ngrid)
       real :: flux_o(ngrid),flux_g(ngrid),fluxgrdocean(ngrid)
-      real :: dt_ekman(ngrid,noceanmx),dt_hdiff(ngrid,noceanmx)
       real :: flux_sens_lat(ngrid)
       real :: qsurfint(ngrid,nq)
 
 
-!=======================================================================
-
-! 1. Initialisation
+!==================================================================================================
+
 ! -----------------
-
-!  1.1   Initialisation only at first call
-!  ---------------------------------------
+! I. INITIALISATION
+! -----------------
+
+! --------------------------------
+! I.1   First Call Initialisation.
+! --------------------------------
       if (firstcall) then
 
-        !!! ALLOCATE SAVED ARRAYS
+        ! Allocate saved arrays.
         ALLOCATE(tsurf(ngrid))
         ALLOCATE(tsoil(ngrid,nsoilmx))    
@@ -507,16 +473,13 @@
         ALLOCATE(zmasq(ngrid))
         ALLOCATE(knindex(ngrid))
-!        ALLOCATE(qsurfint(ngrid,nqmx))
-
-
-        !! this is defined in comsaison_h
+
+        ! This is defined in comsaison_h
         ALLOCATE(mu0(ngrid))
-        ALLOCATE(fract(ngrid))
-
-            
-         !! this is defined in radcommon_h
-         ALLOCATE(glat(ngrid))
-
-!        variables set to 0
+        ALLOCATE(fract(ngrid))            
+         ! This is defined in radcommon_h
+        ALLOCATE(glat(ngrid))
+        
+
+!        Variables set to 0
 !        ~~~~~~~~~~~~~~~~~~
          dtrad(:,:) = 0.0
